
package com.example.bookshare;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import org.apache.http.client.ClientProtocolException;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Build;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class SearchBookActivity extends Activity {

	
	@SuppressLint("NewApi")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_search_book);
		
		 if (Build.VERSION.SDK_INT >= 11) {
		      StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().detectDiskReads     ().detectDiskWrites().detectNetwork().penaltyLog().build());
		   StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder().detectLeakedSqlLiteObjects().detectLeakedClosableObjects().penaltyLog().penaltyDeath().build());
		  }


		String isbn = getIntent().getStringExtra("ISBN") ;
		getInfobyIsbn(isbn);
		

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void getInfobyIsbn(String isbn) {
		String url = "http://api.douban.com/book/subject/isbn/" + isbn
				+ "?alt=json";

		try {

			URL turl = new URL(url);
			StringBuilder builder = new StringBuilder();
			BufferedReader bufferedReader = new BufferedReader(
					new InputStreamReader(turl.openStream()));
			for (String s = bufferedReader.readLine(); s != null; s = bufferedReader
					.readLine()) {
				builder.append(s);
			}
			String jsonstr = builder.toString();

			JSONObject json = new JSONObject(jsonstr);

			String bookname // 
			, authorname // 
			, summary // ݼ
			, imageurl // ͼƬַ
			, isbn10 // 10λISBN
			, isbn13 // 13λISBN
			, publisher // 
			, price; // ۸
			bookname = authorname = summary = imageurl = isbn10 = isbn13 = publisher = price = null;

			if (!json.isNull("title")) {
				bookname = json.getJSONObject("title").getString("$t");
			}

			if (!json.isNull("author")) {
				JSONArray namearray = json.getJSONArray("author");
				for (int i = 0; i < namearray.length(); i++) {
					JSONObject nameobj = namearray.getJSONObject(i);
					authorname = "";
					authorname = authorname
							+ nameobj.getJSONObject("name").getString("$t")
							+ " ";
				}
			}

			if (!json.isNull("summary")) {
				summary = json.getJSONObject("summary").getString("$t");
			}

			if (!json.isNull("db:attribute")) {
				JSONArray attribute = json.getJSONArray("db:attribute");

				for (int i = 0; i < attribute.length(); i++) {
					JSONObject attrobj = attribute.optJSONObject(i);
					String tmp;
					tmp = "isbn10";
					if (tmp.equals(attrobj.getString("@name"))) {
						isbn10 = attrobj.getString("$t");
					}
					tmp = "isbn13";
					if (tmp.equals(attrobj.getString("@name"))) {
						isbn13 = attrobj.getString("$t");
					}
					tmp = "publisher";
					if (tmp.equals(attrobj.getString("@name"))) {
						publisher = attrobj.getString("$t");
					}
					tmp = "price";
					if (tmp.equals(attrobj.getString("@name"))) {
						price = attrobj.getString("$t");
					}
				}
			}

			if (!json.isNull("link")) {
				JSONArray jsonarray = json.getJSONArray("link");
				for (int i = 0; i < jsonarray.length(); i++) {
					JSONObject linkobj = jsonarray.optJSONObject(i);
					String tmp = "image";
					if (tmp.equals(linkobj.getString("@rel"))) {
						imageurl = linkobj.getString("@href");
						break;
					}
				}
			}

			// ȡͼƬ
			imageurl = imageurl.replace("spic", "mpic");

			URL myFileUrl = null;
			Bitmap bitmap = null;

			myFileUrl = new URL(imageurl);

			HttpURLConnection iconn = (HttpURLConnection) myFileUrl
					.openConnection();
			iconn.setDoInput(true);
			iconn.connect();

			InputStream is = iconn.getInputStream();
			bitmap = BitmapFactory.decodeStream(is);
			is.close();

			// ʾϢ
			TextView textview = (TextView) findViewById(R.id.bookNametextview);
			textview.setText(bookname);

			textview = (TextView) findViewById(R.id.authorNametextview);
			textview.setText(authorname);

			textview = (TextView) findViewById(R.id.summarytextview);
			textview.setText(summary);

			textview = (TextView) findViewById(R.id.publishertextview);
			textview.setText(publisher);

			textview = (TextView) findViewById(R.id.pricetextview);
			textview.setText(price);

			textview = (TextView) findViewById(R.id.isbntextview);
			textview.setText(isbn13);

			ImageView imView = (ImageView) findViewById(R.id.bookimageview);
			imView.setImageBitmap(bitmap);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}



